﻿
Public Class Form1

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        EventsAreEnabled = False
        InitSounds()
        ToolTips_Init()
        '
        InitDefaultKeys()
        Load_INI()
        InitParams()
        InitSlots()
        '
        mtimer = New MilliTimer()
        mtimer.Interval = 5
        mtimer.Start()
        '
        Text = AppTitleAndVersion("")
        EventsAreEnabled = True
        '
        ListViewInit()
        ListViewInitRows()
        ListView_UnselectAllLines(MyListView1)
        Refresh()
        Opacity = 1
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        EventsAreEnabled = False
        If mtimer IsNot Nothing Then mtimer.Stop()
        Save_INI()
        'End
    End Sub

    Private Sub Form_LocationChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LocationChanged
        If Not EventsAreEnabled Then Exit Sub
        LimitFormPosition(Me)
    End Sub


    ' ====================================================================================================
    '  Params
    ' ====================================================================================================
    Private FirstSlot As Int32
    Private NumKeys As Int32
    Private RepeatDelay As Int32
    Private RepeatTime As Int32
    Private ClickEnabled As Boolean
    Private Sub Params_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles txt_FirstInputSlot.LostFocus, _
                                                                                              txt_NumInputSlots.LostFocus, _
                                                                                              txt_RepeatDelay.LostFocus, _
                                                                                              txt_RepeatTime.LostFocus, _
                                                                                              chk_EnableClick.LostFocus
        Save_INI()
    End Sub
    Private Sub txt_FirstInputSlot_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_FirstInputSlot.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        InitParams()
        InitSlots()
        ListViewUpdate()
    End Sub
    Private Sub txt_NumInputSlots_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_NumInputSlots.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        InitParams()
        ListViewInitRows()
    End Sub
    Private Sub txt_RepeatDelay_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_RepeatDelay.TextChanged
        InitParams()
    End Sub
    Private Sub txt_RepeatTime_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_RepeatTime.TextChanged
        InitParams()
    End Sub
    Private Sub chk_EnableClick_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chk_EnableClick.CheckedChanged
        InitParams()
    End Sub

    Private Sub InitParams()
        FirstSlot = txt_FirstInputSlot.NumericValueInteger
        NumKeys = txt_NumInputSlots.NumericValueInteger
        RepeatDelay = txt_RepeatDelay.NumericValueInteger \ 5
        RepeatTime = txt_RepeatTime.NumericValueInteger \ 5
        ClickEnabled = chk_EnableClick.Checked
    End Sub


    ' ====================================================================================================
    '  MilliTimer
    ' ====================================================================================================
    Private WithEvents mtimer As MilliTimer
    Private Sub MilliTimerElapsed_ThreadSafe() Handles mtimer.MilliTimerElapsed
        Me.Invoke(New Action(Of Int32)(AddressOf MilliTimerElapsed), 0)
    End Sub
    Private Sub MilliTimerElapsed(ByVal n As Int32)
        PollSlots()
        'TestTime()
    End Sub
    'Private Sub TestTime()
    '    Static t As Double = 0
    '    t = t + mtimer.Interval
    '    If t >= 1000 Then
    '        t = 0
    '        'Beep()
    '        Me.Text = DateTime.Now.Millisecond.ToString
    '    End If
    'End Sub
    Friend Sub PollSlots()
        Dim slot As Int32
        Dim v As Single
        '
        ' -----------------------------------------------------------
        slot = 0
        If slot >= 0 Then
            Dim tripPoint As Single = 100
            For i As Int32 = 0 To NumKeys - 1
                Dim k As KeyEntry = KeysArray(i)
                v = (Slots.ReadSlot_NoNan(k.Slot))
                If v > tripPoint Then
                    PressedKeys_Press(i)
                Else
                    PressedKeys_Release(i)
                End If
            Next
        End If
    End Sub


    ' ====================================================================================================
    '  PressedKeys array
    ' ====================================================================================================
    Private PressedKeys As Hashtable = New Hashtable
    Private Sub PressedKeys_ReleaseAllKeys()
        For n As Int32 = 0 To 127
            PressedKeys_Release(n)
        Next
    End Sub
    Private Sub PressedKeys_Press(ByVal n As Int32)
        MyListView1.Focus()
        ListView_UnselectAllLines(MyListView1)
        If Not PressedKeys.Contains(n) Then
            PressedKeys.Add(n, 0)
            VirtualKeyboard.KeyDown(KeysArray(n).Key)
            ListView_SetLineColors(MyListView1, n, True)
            If ClickEnabled Then PlayClickSound()
        Else
            If RepeatDelay < 9000 Then
                If KeysArray(n).Counter > RepeatDelay Then
                    KeysArray(n).Counter -= RepeatTime
                    VirtualKeyboard.KeyUp(KeysArray(n).Key)
                    ListView_SetLineColors(MyListView1, n, False)
                    VirtualKeyboard.KeyDown(KeysArray(n).Key)
                    ListView_SetLineColors(MyListView1, n, True)
                Else
                    KeysArray(n).Counter += 1
                End If
            End If
        End If
    End Sub
    Private Sub PressedKeys_Release(ByVal n As Int32)
        If PressedKeys.Contains(n) Then
            PressedKeys.Remove(n)
            KeysArray(n).Counter = 0
            VirtualKeyboard.KeyUp(KeysArray(n).Key)
            ListView_SetLineColors(MyListView1, n, False)
        End If
    End Sub


    ' ====================================================================================================
    '  KEYS ARRAY
    ' ====================================================================================================
    Friend Structure KeyEntry
        Dim Slot As Int32
        Dim Key As Keys
        Dim Counter As Int32
    End Structure
    Friend KeysArray(255) As KeyEntry
    Private Sub InitSlots()
        For i As Int32 = 0 To KeysArray.Length - 1
            KeysArray(i).Slot = FirstSlot + i
        Next
    End Sub
    Private Sub InitDefaultKeys()
        KeysArray(0).Key = Keys.Left
        KeysArray(1).Key = Keys.Right
        KeysArray(2).Key = Keys.Up
        KeysArray(3).Key = Keys.Down
        KeysArray(4).Key = Keys.Space
        KeysArray(5).Key = Keys.LButton
        KeysArray(6).Key = Keys.RButton
        KeysArray(7).Key = Keys.Enter
        KeysArray(8).Key = Keys.Escape
        KeysArray(9).Key = Keys.None
        KeysArray(10).Key = Keys.Q
        KeysArray(11).Key = Keys.W
        KeysArray(12).Key = Keys.E
        KeysArray(13).Key = Keys.R
        KeysArray(14).Key = Keys.T
        KeysArray(15).Key = Keys.Y
        KeysArray(16).Key = Keys.U
        KeysArray(17).Key = Keys.I
        KeysArray(18).Key = Keys.O
        KeysArray(19).Key = Keys.P
        KeysArray(20).Key = Keys.A
        KeysArray(21).Key = Keys.S
        KeysArray(22).Key = Keys.D
        KeysArray(23).Key = Keys.F
        KeysArray(24).Key = Keys.G
        KeysArray(25).Key = Keys.H
        KeysArray(26).Key = Keys.J
        KeysArray(27).Key = Keys.K
        KeysArray(28).Key = Keys.L
        KeysArray(29).Key = Keys.Z
        KeysArray(30).Key = Keys.X
        KeysArray(31).Key = Keys.C
        KeysArray(32).Key = Keys.V
        KeysArray(33).Key = Keys.B
        KeysArray(34).Key = Keys.N
        KeysArray(35).Key = Keys.M
        KeysArray(36).Key = Keys.D1
        KeysArray(37).Key = Keys.D2
        KeysArray(38).Key = Keys.D3
        KeysArray(39).Key = Keys.D4
        KeysArray(40).Key = Keys.D5
        KeysArray(41).Key = Keys.D6
        KeysArray(42).Key = Keys.D7
        KeysArray(43).Key = Keys.D8
        KeysArray(44).Key = Keys.D9
        KeysArray(45).Key = Keys.D0
        KeysArray(46).Key = Keys.F1
        KeysArray(47).Key = Keys.F2
        KeysArray(48).Key = Keys.F3
        KeysArray(49).Key = Keys.F4
        KeysArray(50).Key = Keys.F5
        KeysArray(51).Key = Keys.F6
        KeysArray(52).Key = Keys.F7
        KeysArray(53).Key = Keys.F8
        KeysArray(54).Key = Keys.F9
        KeysArray(55).Key = Keys.F10
        KeysArray(56).Key = Keys.F11
        KeysArray(57).Key = Keys.F12
        KeysArray(58).Key = Keys.Shift
        KeysArray(59).Key = Keys.Control
        KeysArray(60).Key = Keys.Add
        KeysArray(61).Key = Keys.Subtract
        KeysArray(62).Key = Keys.Multiply
        KeysArray(63).Key = Keys.Divide
        KeysArray(64).Key = Keys.Oemplus
        KeysArray(65).Key = Keys.OemMinus
        KeysArray(66).Key = Keys.Insert
        KeysArray(67).Key = Keys.Tab
        KeysArray(68).Key = Keys.Delete
        KeysArray(69).Key = Keys.Back
        For i As Int32 = 70 To KeysArray.Length - 1
            KeysArray(i).Key = Keys.None
        Next
    End Sub


    ' ==============================================================================================================
    '   LIST VIEW
    ' ==============================================================================================================
    Friend PressedKeyboardKey As Keys = Keys.None
    Friend PressedMouseButton As Windows.Forms.MouseButtons
    Private Sub MyListView1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyListView1.Click
        If MyListView1.SelectedIndices.Count < 1 Then Return
        Dim row As Int32 = MyListView1.SelectedIndices(0)
        PressedKeyboardKey = Keys.None
        PressedMouseButton = MouseButtons.None
        Form2.Left = Cursor.Position.X - 220
        Form2.Top = Cursor.Position.Y + 10
        Dim result As DialogResult = Form2.ShowDialog(Me)
        Select Case result
            Case Windows.Forms.DialogResult.Cancel
                Return
            Case Windows.Forms.DialogResult.Yes
                InitDefaultKeys()
            Case Windows.Forms.DialogResult.OK
                Select Case PressedMouseButton
                    Case Windows.Forms.MouseButtons.Left
                        KeysArray(row).Key = Keys.LButton
                    Case Windows.Forms.MouseButtons.Right
                        KeysArray(row).Key = Keys.RButton
                    Case Windows.Forms.MouseButtons.Middle
                        KeysArray(row).Key = Keys.MButton
                    Case Else
                        KeysArray(row).Key = PressedKeyboardKey
                End Select
        End Select
        ListViewInitRows()
        Save_INI()
    End Sub
    Private Sub MyListView1_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyListView1.KeyDown
        e.Handled = True
    End Sub
    Private Sub MyListView1_ColumnWidthChanging(ByVal sender As Object, ByVal e As System.Windows.Forms.ColumnWidthChangingEventArgs) Handles MyListView1.ColumnWidthChanging
        e.Cancel = True
        e.NewWidth = MyListView1.Columns(e.ColumnIndex).Width
    End Sub
    Private Sub ListView_SetLineColors(ByVal lv As CustomControlsLib.MyListView, ByVal line As Int32, ByVal pressed As Boolean)
        If line < 0 Or line >= lv.Items.Count Then Return
        If OperatingSystemIsWindows Then
            lv.SetExtStyle_DoubleBuffering()
            lv.BeginUpdate()
        End If
        With lv.Items(line)
            If pressed Then
                .BackColor = Color.FromArgb(0, 0, 120)
                .ForeColor = Color.Yellow
            Else
                .BackColor = Color.FromArgb(255, 255, 255)
                .ForeColor = Color.Black
            End If
        End With
        If OperatingSystemIsWindows Then
            lv.EndUpdate()
        End If
    End Sub
    Friend Sub ListViewInit()
        With MyListView1
            .GridLines = True
            .FullRowSelect = True
            .Header_BackColor1 = Color.FromArgb(255, 255, 200)
            .Header_BackColor2 = Color.FromArgb(200, 200, 200)
            .Header_ForeColor = Color.FromArgb(20, 20, 20)
            .Header_ShadowColor = Color.FromArgb(255, 255, 255)
            .Header_Font = New Font("Tahoma", 10, FontStyle.Regular)
            .Font = New Font("Tahoma", 9, FontStyle.Bold)
            .View = View.Details
            .Columns.Add("Slot", 32, HorizontalAlignment.Left)
            .Columns.Add("Key", 82, HorizontalAlignment.Left)
        End With
    End Sub

    Friend Sub ListViewInitRows()
        With MyListView1
            If OperatingSystemIsWindows Then
                .SetExtStyle_DoubleBuffering()
                .BeginUpdate()
            End If
            .Items.Clear()
            For i As Int32 = 0 To NumKeys - 1
                Dim k As KeyEntry = KeysArray(i)
                .Items.Add(k.Slot.ToString("00")).SubItems.Add(k.Key.ToString)
            Next
            If OperatingSystemIsWindows Then
                .EndUpdate()
            End If
        End With
    End Sub

    Friend Sub ListViewUpdate()
        With MyListView1
            If OperatingSystemIsWindows Then
                .SetExtStyle_DoubleBuffering()
                .BeginUpdate()
            End If
            For i As Int32 = 0 To NumKeys - 1
                Dim k As KeyEntry = KeysArray(i)
                .Items(i).SubItems(0).Text = k.Slot.ToString("00")
                .Items(i).SubItems(1).Text = k.Key.ToString
            Next
            If OperatingSystemIsWindows Then
                .EndUpdate()
            End If
        End With
    End Sub


    ' ==============================================================================================================
    '   ToolTips
    ' ==============================================================================================================
    Private ttp1 As ToolTip
    Private Sub ToolTips_Init()
        ttp1 = New ToolTip
        ttp1.ShowAlways = True
        ttp1.UseAnimation = True
        ttp1.UseFading = True
        ttp1.IsBalloon = True
        ttp1.AutoPopDelay = 32700
        ttp1.InitialDelay = 700
        ttp1.ReshowDelay = 500
        ' --------------------------------------------------------------- Add here Controls and ToolTip-Text
        ttp1.SetToolTip(txt_FirstInputSlot, _
                        " First input slot" & vbCrLf & _
                        " - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -" & vbCrLf & _
                        " The number of the first slot to read." & vbCrLf & _
                        " A consecutive number of slots are read starting from this slot.")

        ttp1.SetToolTip(txt_NumInputSlots, _
                        " Number of slots" & vbCrLf & _
                        " - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -" & vbCrLf & _
                        " The number of the consecutive slots to read.")

        ttp1.SetToolTip(txt_RepeatDelay, _
                        " Repeat delay" & vbCrLf & _
                        " - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -" & vbCrLf & _
                        " The time in milliseconds before to start of the auto-repeat." & vbCrLf & _
                        " A normal value is 250" & vbCrLf & _
                        " A value greater than 9000, stops the auto-repeat." & vbCrLf & _
                        " With a small value the auto-repeat starts immediately.")

        ttp1.SetToolTip(txt_RepeatTime, _
                        " Repeat time" & vbCrLf & _
                        " - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -" & vbCrLf & _
                        " The time in milliseconds from each auto-repeat." & vbCrLf & _
                        " A normal value is 25" & vbCrLf & _
                        " Increase this value to get a slow auto-repeat." & vbCrLf & _
                        " Reduce this value to get a fast auto-repeat.")

        ttp1.SetToolTip(chk_EnableClick, _
                       " Enable click" & vbCrLf & _
                       " - - - - - - - - - - - - - - - - - - - - - - - - - - -" & vbCrLf & _
                       " A click sound for each key-down event.")
    End Sub

    ' --------------------- this corrects the XP bug that causes tooltip disappearing for ever 
    Private Sub controls_MouseEnter(ByVal sender As Object, _
                                   ByVal e As System.EventArgs) Handles txt_FirstInputSlot.MouseEnter, _
                                                                        txt_NumInputSlots.MouseEnter, _
                                                                        txt_RepeatDelay.MouseEnter, _
                                                                        txt_RepeatTime.MouseEnter
        ttp1.Active = False
        ttp1.Active = True
    End Sub

End Class